#pragma once

#include "core/time.h"
#include "core/gameevent.h"

#include <memory>

class ClassicGraphicsManager : public std::enable_shared_from_this<ClassicGraphicsManager>
{
public:
    virtual ~ClassicGraphicsManager() = default;
    explicit ClassicGraphicsManager(const kku::microsec& visibility_offset) :
        _visibility_offset(visibility_offset)
    {}

    virtual void input(kku::GameEvent&& input) = 0;
    virtual void display() const = 0;
    virtual void update(const kku::microsec& offset) = 0;

protected:
    kku::microsec _visibility_offset;
};
